﻿package  {

	//Put this into a package for use to keep code libraries instead of
	//ad-hoc Classes all over the place. Thumbs will be Classes and you'll 
	//need a thumb manager anyway, so keep things tidy.
	
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.geom.Rectangle;
	
	//Change this to point to your local TweenMax source in the FLA.
	//Otherwise you'll get a compilation error.
	import com.greensock.TweenMax;
	
	/**
	2009 ActionScript 3.0
	------------------------------------------------------------------------------
	This is a simple test of a custom slider with three thumbs. It is in no way
	dynamic. You cannot build from code or adjust with code. That would be an
	obvious next step if you feel that you'd need that kind of control for your
	project or use. This needs a lot of work to make it dynamic, the code below
	is awfully nasty but for a one-off at the moment it's okay. After dynamic
	creation one could also set the thumb positions with code instead of dragging
	and then animate the thumbs into position (with a check for overlap).
	
	NOTE: this is not fully realized in any way. You cannot currently drag an
	outside thumb to the end of the range (0 or 18). 
	*/
	public class baseSlider extends Sprite {
		
		private var bDragging:Boolean = false;
		private var nBufferPixels:int = 10;
		private var nLimit:int = 18;
		
		public function baseSlider()
		{
			setupListeners();
			slider.thumb_1.block.alpha = 0;
			slider.thumb_1.txt_1.alpha = 0;
			slider.thumb_2.block.alpha = 0;
			slider.thumb_2.txt_1.alpha = 0;
			slider.thumb_3.block.alpha = 0;
			slider.thumb_3.txt_1.alpha = 0;
			updateValues();
			setPositions( 1.5, 13, 16 );
		}
		
		private function setupListeners():void
		{
			slider.thumb_1.thumb.addEventListener( MouseEvent.MOUSE_DOWN, thumbPress );
			slider.thumb_1.thumb.addEventListener( MouseEvent.MOUSE_UP, thumbRelease );
			slider.thumb_1.thumb.addEventListener( MouseEvent.MOUSE_OVER, thumbOver );
			slider.thumb_1.thumb.addEventListener( MouseEvent.MOUSE_OUT, thumbOut );
			slider.thumb_2.thumb.addEventListener( MouseEvent.MOUSE_DOWN, thumbPress );
			slider.thumb_2.thumb.addEventListener( MouseEvent.MOUSE_UP, thumbRelease );
			slider.thumb_2.thumb.addEventListener( MouseEvent.MOUSE_OVER, thumbOver );
			slider.thumb_2.thumb.addEventListener( MouseEvent.MOUSE_OUT, thumbOut );
			slider.thumb_3.thumb.addEventListener( MouseEvent.MOUSE_DOWN, thumbPress );
			slider.thumb_3.thumb.addEventListener( MouseEvent.MOUSE_UP, thumbRelease );
			slider.thumb_3.thumb.addEventListener( MouseEvent.MOUSE_OVER, thumbOver );
			slider.thumb_3.thumb.addEventListener( MouseEvent.MOUSE_OUT, thumbOut );
			stage.addEventListener( MouseEvent.MOUSE_UP, thumbRelease );
		}
		
		private function thumbOver( e:MouseEvent ):void
		{
			TweenMax.to( e.currentTarget.parent.block, 0.5, { alpha:1 });
			TweenMax.to( e.currentTarget.parent.txt_1, 0.5, { alpha:1 });
		}
		
		private function thumbOut( e:MouseEvent ):void
		{
			if( !bDragging ){
				TweenMax.to( e.currentTarget.parent.block, 0.5, { alpha:0 });
				TweenMax.to( e.currentTarget.parent.txt_1, 0.5, { alpha:0 });
			}
		}
		
		private function thumbPress( e:MouseEvent ):void 
		{
			stage.addEventListener( Event.ENTER_FRAME, updateBars );
			var boundsRectangle:Rectangle;
			switch( e.currentTarget.parent.name )
			{
				case "thumb_1":
					boundsRectangle = new Rectangle( 32+nBufferPixels, 15, slider.thumb_2.x - nBufferPixels - 42, 0 );
					break;
				case "thumb_2":
					boundsRectangle = new Rectangle( slider.thumb_1.x + nBufferPixels, 15, slider.thumb_3.x - slider.thumb_1.x - 20, 0 );
					break;
				case "thumb_3":
					boundsRectangle = new Rectangle( slider.thumb_2.x + nBufferPixels, 15, slider.end_MC.x - slider.thumb_2.x - nBufferPixels - 10, 0 );
					break;
				default:
					break;
			}
			bDragging = true;
			e.currentTarget.parent.startDrag( true, boundsRectangle );
		}
		
		private function thumbRelease( e:MouseEvent ):void
		{
			if( e.currentTarget == stage )
			{
				slider.thumb_1.stopDrag();
				slider.thumb_2.stopDrag();
				slider.thumb_3.stopDrag();
				TweenMax.to( slider.thumb_1.block, 0.5, { alpha:0 });
				TweenMax.to( slider.thumb_1.txt_1, 0.5, { alpha:0 });
				TweenMax.to( slider.thumb_2.block, 0.5, { alpha:0 });
				TweenMax.to( slider.thumb_2.txt_1, 0.5, { alpha:0 });
				TweenMax.to( slider.thumb_3.block, 0.5, { alpha:0 });
				TweenMax.to( slider.thumb_3.txt_1, 0.5, { alpha:0 });
			} else {
				e.currentTarget.parent.stopDrag();
			}
			stage.removeEventListener( Event.ENTER_FRAME, updateBars );
			bDragging = false;
		}
		
		private function updateBars( e:Event ):void
		{
			realUpdateBars();
			updateValues();
		}
		
		private function realUpdateBars():void
		{
			slider.color_1.width = slider.thumb_1.x - 32;
			slider.color_2.x = slider.thumb_1.x;
			slider.color_2.width = slider.thumb_2.x - slider.thumb_1.x;
			slider.color_3.x = slider.thumb_2.x;
			slider.color_3.width = slider.thumb_3.x - slider.thumb_2.x;
			slider.color_4.x = slider.thumb_3.x;
			slider.color_4.width = slider.end_MC.x - slider.thumb_3.x;
		}
		
		//Translate the % of position to a numeral. The 18 represents the full value (uglee).
		private function updateValues():void
		{
			var w:Number = slider.bar.width;
			var percentageThumbOne:Number = (slider.thumb_1.x - slider.bar.x)+2.3;
			var oneApply = (percentageThumbOne/w * 100);
			oneApply = oneApply.toFixed(1);
			var oneA = nLimit * (oneApply/100);
			oneA = oneA.toFixed(1);
			slider.thumb_1.txt_1.text = oneA;
			
			var percentageThumbTwo:Number = (slider.thumb_2.x - slider.bar.x)+2.3;
			var twoApply = (percentageThumbTwo/w * 100);
			twoApply = twoApply.toFixed(1);
			var twoA = nLimit * (twoApply/100);
			twoA = twoA.toFixed(1);
			slider.thumb_2.txt_1.text = twoA;
			
			var percentageThumbThree:Number = (slider.thumb_3.x - slider.bar.x)+2.3;
			var threeApply = (percentageThumbThree/w * 100);
			threeApply = threeApply.toFixed(1);
			var threeA = nLimit * (threeApply/100);
			threeA = threeA.toFixed(1);
			slider.thumb_3.txt_1.text = threeA;
			feedback_txt.text = "1:  " + oneA + "\n2:  " + twoA + "\n3:  " + threeA;
			realUpdateBars();
		}
		
		//18 represents the full value. No check is made here.
		private function setPositions( n1:Number, n2:Number, n3:Number ):void
		{
			//find pixel location in which to place thumbs for values
			var w:Number = slider.bar.width;
			var pos1 = n1/nLimit; //% of the whole
			pos1 = (w * pos1) + slider.bar.x - 2.3;
			slider.thumb_1.x = pos1;
		
			var pos2 = n2/nLimit; //% of the whole
			pos2 = (w * pos2) + slider.bar.x - 2.3;
			slider.thumb_2.x = pos2;
			
			var pos3 = n3/nLimit; //% of the whole
			pos3 = (w * pos3) + slider.bar.x - 2.3;
			slider.thumb_3.x = pos3;
			
			updateValues();
		}
	}
}